package cn.bran.japid.util;

public class JapidFlags {
	static enum LogLevel{
		debug(0), info(1), warn(2), error(3);
		LogLevel(int i) {
			this.level = i;
		}
		
		int level;

		/**
		 * @author Bing Ran (bing.ran@gmail.com)
		 * @param debug2
		 * @return
		 */
		public boolean noLowerThan(LogLevel debug2) {
			return level >= debug2.level;
		}
		
	}
	
	static LogLevel logLevel = LogLevel.warn;
	
	public static boolean verbose = true;

	/**
	 * @author Bing Ran (bing.ran@hotmail.com)
	 * @param string
	 */
	public static void log(String string) {
		if (!string.startsWith("["))
			string = "[Japid]" + " " + string.trim();
			
		if (verbose)
			out(string);
	}

	private static void out(String string) {
		System.out.println(string);
	}

	/**
	 * @author Bing Ran (bing.ran@gmail.com)
	 * @param string
	 */
	public static void debug(String string) {
		if (LogLevel.debug.noLowerThan(logLevel)) {
			out(string);
		}
	}

	public static void setLogLevel(LogLevel l) {
		logLevel = l;
	}
}
